Index: LMDZ6/branches/Amaury_dev/libf/phylmd/inlandsis/sisvat_ts2.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/inlandsis/sisvat_ts2.f90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/inlandsis/sisvat_ts2.f90	(revision 5143)
@@ -67,4 +67,6 @@
   USE indice_sol_mod
   USE lmdz_comsoil, ONLY: inertie_sol, inertie_sno, inertie_sic, inertie_lic, iflag_sic, iflag_inertie
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
   IMPLICIT NONE
@@ -75,6 +77,4 @@
 
   INCLUDE "YOMCST.h"
-  INCLUDE "YOETHF.h"
-  INCLUDE "FCTTRE.h"
   ! INCLUDE "indicesol.h"
   ! include  "LMDZphy.inc"
@@ -263,5 +263,5 @@
             * TsisSV(ig, isl)                     & !
             * TsisSV(ig, isl)
-    IRs__D(ig) = dIRsdT(ig)* TsisSV(ig, isl) * 0.75                  !:
+    IRs__D(ig) = dIRsdT(ig) * TsisSV(ig, isl) * 0.75                  !:
   END DO
   !hj
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_FCTTRE.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_FCTTRE.f90	(revision 5143)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_FCTTRE.f90	(revision 5143)
@@ -0,0 +1,57 @@
+MODULE lmdz_fcttre
+  !     ------------------------------------------------------------------
+  !     This COMDECK includes the Thermodynamical functions for the cy39
+  !       ECMWF Physics package.
+  !       Consistent with YOMCST Basic physics constants, assuming the
+  !       partial pressure of water vapour is given by a first order
+  !       Taylor expansion of Qs(T) w.r.t. to Temperature, using constants
+  !       in YOETHF
+  !     ------------------------------------------------------------------
+
+  IMPLICIT NONE; PRIVATE
+  PUBLIC foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
+  LOGICAL, PARAMETER :: thermcep = .TRUE.
+
+CONTAINS
+
+  REAL FUNCTION foeew (ptarg, pdelarg)
+    USE lmdz_YOETHF, ONLY: r3ies, r3les, r4ies, r4les
+    INCLUDE "YOMCST.h"  ! rtt
+    REAL, INTENT(IN) :: ptarg, pdelarg
+    foeew = exp ((r3les * (1. - pdelarg) + r3ies * pdelarg) * (ptarg - rtt) &
+            / (ptarg - (r4les * (1. - pdelarg) + r4ies * pdelarg)))
+  END FUNCTION foeew
+
+  REAL FUNCTION foede (ptarg, pdelarg, p5arg, pqsarg, pcoarg)
+    USE lmdz_YOETHF, ONLY: r4ies, r4les
+    REAL, INTENT(IN) :: ptarg, pdelarg, p5arg, pqsarg, pcoarg
+    foede = pqsarg * pcoarg * p5arg / (ptarg - (r4les * (1. - pdelarg) + r4ies * pdelarg))**2
+  END FUNCTION foede
+
+  REAL FUNCTION qsats(ptarg)
+    REAL, INTENT(IN) :: ptarg
+    qsats = 100.0 * 0.622 * 10.0 ** (2.07023 - 0.00320991 * ptarg - 2484.896 / ptarg + 3.56654 * log10(ptarg))
+  END FUNCTION qsats
+
+  REAL FUNCTION qsatl(ptarg)
+    REAL, INTENT(IN) :: ptarg
+    qsatl = 100.0 * 0.622 * 10.0 ** (23.8319 - 2948.964 / ptarg - 5.028 * log10(ptarg) &
+            - 29810.16 * exp(- 0.0699382 * ptarg) + 25.21935 * exp(- 2999.924 / ptarg))
+  END FUNCTION qsatl
+
+  REAL FUNCTION dqsats(ptarg, pqsarg)
+    REAL, INTENT(IN) :: ptarg, pqsarg
+    INCLUDE "YOMCST.h"  ! rlvtt, rcpd
+    dqsats = rlvtt / rcpd * pqsarg * (3.56654 / ptarg + 2484.896 * log(10.) / ptarg**2 - 0.00320991 * log(10.))
+  END FUNCTION dqsats
+
+  REAL FUNCTION dqsatl(ptarg, pqsarg)
+    REAL, INTENT(IN) :: ptarg, pqsarg
+    INCLUDE "YOMCST.h"  ! rlvtt, rcpd
+    dqsatl = rlvtt / rcpd * pqsarg * log(10.) * (2948.964 / ptarg**2 - 5.028 / log(10.) / ptarg &
+            + 25.21935 * 2999.924 / ptarg**2 * exp(-2999.924 / ptarg) + &
+            29810.16 * 0.0699382 * exp(-0.0699382 * ptarg))
+  END FUNCTION dqsatl
+
+END MODULE lmdz_fcttre
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOEGWD.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOEGWD.f90	(revision 5143)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOEGWD.f90	(revision 5143)
@@ -0,0 +1,22 @@
+!*    *COMMON* *YOEGWD* - PARAMETERS FOR GRAVITY WAVE DRAG CALCULATIONS
+MODULE lmdz_YOEGWD
+  IMPLICIT NONE; PRIVATE
+  PUBLIC GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
+  INTEGER NKTOPG, NSTRA
+  REAL GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT
+  REAL GHMAX, GRAHILO, GSIGCR, GSSEC, GTSEC, GVSEC
+
+  REAL GWD_RANDO_RUWMAX
+  !     Maximum Eliassen-Palm flux at launch level, in "FLOTT_GWD_rando"
+
+  REAL GWD_RANDO_SAT ! saturation parameter in "FLOTT_GWD_rando"
+  !     S_c in equation (12) of Lott (JGR, vol 118, page 8897, 2013)
+
+  REAL GWD_FRONT_RUWMAX, GWD_FRONT_SAT
+  ! Same as GWD_RANDO params but for fronal GWs
+
+  !$OMP THREADPRIVATE(GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+  !$OMP          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat)
+END MODULE lmdz_YOEGWD
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOETHF.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOETHF.f90	(revision 5143)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_YOETHF.f90	(revision 5143)
@@ -0,0 +1,24 @@
+MODULE lmdz_YOETHF
+  !*    COMMON *YOETHF* DERIVED CONSTANTS SPECIFIC TO ECMWF THERMODYNAMICS
+
+  !     *R__ES*   *CONSTANTS USED FOR COMPUTATION OF SATURATION
+  !                MIXING RATIO OVER LIQUID WATER(*R_LES*) OR
+  !                ICE(*R_IES*).
+  !     *RVTMP2*  *RVTMP2=RCPV/RCPD-1.
+  !     *RHOH2O*  *DENSITY OF LIQUID WATER.   (RATM/100.)
+  IMPLICIT NONE; PRIVATE
+  PUBLIC R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES, RVTMP2, RHOH2O, R5ALVCP, &
+          R5ALSCP, RALVDCP, RALSDCP, RALFDCP, RTWAT, RTBER, RTBERCU, RTICE, RTICECU, &
+          RTWAT_RTICE_R, RTWAT_RTICECU_R, RKOOP1, RKOOP2, OK_BAD_ECMWF_THERMO
+
+  REAL R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES
+  REAL RVTMP2, RHOH2O
+  REAL R5ALVCP, R5ALSCP, RALVDCP, RALSDCP, RALFDCP, RTWAT, RTBER, RTBERCU
+  REAL RTICE, RTICECU, RTWAT_RTICE_R, RTWAT_RTICECU_R, RKOOP1, RKOOP2
+  LOGICAL OK_BAD_ECMWF_THERMO ! If TRUE, then variables set by rrtm/suphec.F90
+  ! If FALSE, then variables set by suphel.F90
+
+  !$OMP THREADPRIVATE(R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES, RVTMP2, RHOH2O, R5ALVCP, &
+  !$OMP      R5ALSCP, RALVDCP, RALSDCP, RALFDCP, RTWAT, RTBER, RTBERCU, RTICE, RTICECU,&
+  !$OMP      RTWAT_RTICE_R, RTWAT_RTICECU_R, RKOOP1, RKOOP2, OK_BAD_ECMWF_THERMO)
+END MODULE lmdz_YOETHF
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_alpale.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_alpale.f90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_alpale.f90	(revision 5143)
@@ -44,4 +44,5 @@
     USE phys_local_var_mod, ONLY: zw2       ! Variables internes non sauvegardees de la physique
     USE lmdz_abort_physic, ONLY: abort_physic
+    USE lmdz_YOETHF
 
     IMPLICIT NONE
@@ -74,5 +75,4 @@
 
     include "YOMCST.h"
-    include "YOETHF.h"
 
     ! Local variables
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cloudth.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cloudth.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_cloudth.F90	(revision 5143)
@@ -14,4 +14,6 @@
 
       USE lmdz_cloudth_ini, ONLY: iflag_cloudth_vert,iflag_ratqs
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
@@ -26,6 +28,4 @@
 
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
 
       INTEGER itap,ind1,ind2
@@ -265,11 +265,11 @@
 
       USE lmdz_cloudth_ini, ONLY: iflag_cloudth_vert, vert_alpha
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
 
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
-      
+
       INTEGER itap,ind1,ind2
       INTEGER ngrid,klev,klon,l,ig 
@@ -585,4 +585,6 @@
 
       USE lmdz_cloudth_ini, ONLY: iflag_cloudth_vert
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
@@ -597,6 +599,4 @@
 
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
 
       INTEGER, INTENT(IN) :: ind2
@@ -818,13 +818,11 @@
       USE lmdz_cloudth_ini, ONLY: iflag_cloudth_vert,iflag_ratqs
       USE lmdz_cloudth_ini, ONLY: vert_alpha,vert_alpha_th, sigma1s_factor, sigma1s_power , sigma2s_factor , sigma2s_power , cloudth_ratqsmin , iflag_cloudth_vert_noratqs
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
 
-
-
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
-      
+
       INTEGER itap,ind1,ind2
       INTEGER ngrid,klev,klon,l,ig 
@@ -1231,11 +1229,10 @@
 
       USE lmdz_cloudth_ini, ONLY: iflag_cloudth_vert
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
 
-
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
 
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_conema3.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_conema3.f90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_conema3.f90	(revision 5143)
@@ -27,4 +27,7 @@
     USE dimphy
     USE infotrac_phy, ONLY: nbtr
+    USE lmdz_YOETHF
+    USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
     IMPLICIT NONE
     ! ======================================================================
@@ -193,6 +196,4 @@
 
     include "YOMCST.h"
-    include "YOETHF.h"
-    include "FCTTRE.h"
 
     IF (first) THEN
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_old.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_old.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_old.F90	(revision 5143)
@@ -24,6 +24,6 @@
   USE lmdz_lscp_ini, ONLY: cld_tau_lsc, cld_tau_con, cld_lc_lsc, cld_lc_con
   USE lmdz_lscp_ini, ONLY: reevap_ice, iflag_bergeron, iflag_fisrtilp_qsat, iflag_pdf 
-
-
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
   IMPLICIT NONE
@@ -54,6 +54,4 @@
   !======================================================================
   include "YOMCST.h"
-  include "YOETHF.h"
-  include "FCTTRE.h"
 
   ! Principaux inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_tools.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_tools.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_lscp_tools.F90	(revision 5143)
@@ -511,11 +511,10 @@
     ! Calculate qsat following ECMWF method
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
     IMPLICIT NONE
 
     include "YOMCST.h"
-    include "YOETHF.h"
-    include "FCTTRE.h"
 
     INTEGER, INTENT(IN) :: klon  ! number of horizontal grid points
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_ratqs_multi.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_ratqs_multi.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_ratqs_multi.F90	(revision 5143)
@@ -13,10 +13,6 @@
 ! total water subgrid distribution.
 !=============================================
-
+USE lmdz_YOETHF
 IMPLICIT NONE
-
-!=============================================
-    INCLUDE "YOETHF.h"
-
 
       CONTAINS
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_alp.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_alp.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_alp.F90	(revision 5143)
@@ -22,4 +22,6 @@
       USE lmdz_thermcell_main, ONLY: thermcell_tke_transport
       USE lmdz_alpale
+      USE lmdz_YOETHF
+      USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 
       IMPLICIT NONE
@@ -40,6 +42,4 @@
 
       INCLUDE "YOMCST.h"
-      INCLUDE "YOETHF.h"
-      INCLUDE "FCTTRE.h"
 
 !   arguments:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_old.F90	(revision 5143)
@@ -718,4 +718,7 @@
 
     USE dimphy
+    USE lmdz_YOETHF
+    USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
     IMPLICIT NONE
 
@@ -745,6 +748,4 @@
 
     include "YOMCST.h"
-    include "YOETHF.h"
-    include "FCTTRE.h"
 
     ! arguments:
@@ -2313,4 +2314,7 @@
 
     USE dimphy
+    USE lmdz_YOETHF
+    USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
     IMPLICIT NONE
 
@@ -2340,6 +2344,4 @@
 
     include "YOMCST.h"
-    include "YOETHF.h"
-    include "FCTTRE.h"
 
     ! arguments:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_qsat.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_qsat.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_thermcell_qsat.F90	(revision 5143)
@@ -3,10 +3,9 @@
 
 SUBROUTINE thermcell_qsat(klon,active,pplev,ztemp,zqta,zqsat)
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
 IMPLICIT NONE
 
   INCLUDE "YOMCST.h"
-  INCLUDE "YOETHF.h"
-  INCLUDE "FCTTRE.h"
-
 
 !====================================================================
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/nonlocal.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/nonlocal.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/nonlocal.F90	(revision 5143)
@@ -1,9 +1,11 @@
-
 ! $Header$
 
 ! ======================================================================
 SUBROUTINE nonlocal(knon, paprs, pplay, tsol, beta, u, v, t, q, cd_h, cd_m, &
-    pcfh, pcfm, cgh, cgq)
+        pcfh, pcfm, cgh, cgq)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
   ! ======================================================================
@@ -27,5 +29,5 @@
   REAL tsol(klon) ! temperature du sol (K)
   REAL beta(klon) ! efficacite d'evaporation (entre 0 et 1)
-  REAL paprs(klon, klev+1) ! pression a inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression a inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
   REAL u(klon, klev) ! vitesse U (m/s)
@@ -38,31 +40,31 @@
   INTEGER isommet
   REAL vk
-  PARAMETER (vk=0.40)
+  PARAMETER (vk = 0.40)
   REAL ricr
-  PARAMETER (ricr=0.4)
+  PARAMETER (ricr = 0.4)
   REAL fak
-  PARAMETER (fak=8.5)
+  PARAMETER (fak = 8.5)
   REAL fakn
-  PARAMETER (fakn=7.2)
+  PARAMETER (fakn = 7.2)
   REAL onet
-  PARAMETER (onet=1.0/3.0)
+  PARAMETER (onet = 1.0 / 3.0)
   REAL t_coup
-  PARAMETER (t_coup=273.15)
+  PARAMETER (t_coup = 273.15)
   REAL zkmin
-  PARAMETER (zkmin=0.01)
+  PARAMETER (zkmin = 0.01)
   REAL betam
-  PARAMETER (betam=15.0)
+  PARAMETER (betam = 15.0)
   REAL betah
-  PARAMETER (betah=15.0)
+  PARAMETER (betah = 15.0)
   REAL betas
-  PARAMETER (betas=5.0)
+  PARAMETER (betas = 5.0)
   REAL sffrac
-  PARAMETER (sffrac=0.1)
+  PARAMETER (sffrac = 0.1)
   REAL binm
-  PARAMETER (binm=betam*sffrac)
+  PARAMETER (binm = betam * sffrac)
   REAL binh
-  PARAMETER (binh=betah*sffrac)
+  PARAMETER (binh = betah * sffrac)
   REAL ccon
-  PARAMETER (ccon=fak*sffrac*vk)
+  PARAMETER (ccon = fak * sffrac * vk)
 
   REAL z(klon, klev)
@@ -107,7 +109,4 @@
   REAL fac, pblmin, zmzp, term
 
-  include "YOETHF.h"
-  include "FCTTRE.h"
-
   ! Initialisation
 
@@ -131,11 +130,11 @@
 
   DO i = 1, knon
-    z(i, 1) = rd*t(i, 1)/(0.5*(paprs(i,1)+pplay(i,1)))*(paprs(i,1)-pplay(i,1) &
-      )/rg
+    z(i, 1) = rd * t(i, 1) / (0.5 * (paprs(i, 1) + pplay(i, 1))) * (paprs(i, 1) - pplay(i, 1) &
+            ) / rg
   END DO
   DO k = 2, klev
     DO i = 1, knon
-      z(i, k) = z(i, k-1) + rd*0.5*(t(i,k-1)+t(i,k))/paprs(i, k)*(pplay(i,k-1 &
-        )-pplay(i,k))/rg
+      z(i, k) = z(i, k - 1) + rd * 0.5 * (t(i, k - 1) + t(i, k)) / paprs(i, k) * (pplay(i, k - 1 &
+              ) - pplay(i, k)) / rg
     END DO
   END DO
@@ -143,32 +142,32 @@
   DO i = 1, knon
     IF (thermcep) THEN
-      zdelta = max(0., sign(1.,rtt-tsol(i)))
-      zcvm5 = r5les*rlvtt*(1.-zdelta) + r5ies*rlstt*zdelta
-      zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*q(i,1))
-      zxqs = r2es*foeew(tsol(i), zdelta)/paprs(i, 1)
+      zdelta = max(0., sign(1., rtt - tsol(i)))
+      zcvm5 = r5les * rlvtt * (1. - zdelta) + r5ies * rlstt * zdelta
+      zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * q(i, 1))
+      zxqs = r2es * foeew(tsol(i), zdelta) / paprs(i, 1)
       zxqs = min(0.5, zxqs)
-      zcor = 1./(1.-retv*zxqs)
-      zxqs = zxqs*zcor
+      zcor = 1. / (1. - retv * zxqs)
+      zxqs = zxqs * zcor
     ELSE
       IF (tsol(i)<t_coup) THEN
-        zxqs = qsats(tsol(i))/paprs(i, 1)
+        zxqs = qsats(tsol(i)) / paprs(i, 1)
       ELSE
-        zxqs = qsatl(tsol(i))/paprs(i, 1)
+        zxqs = qsatl(tsol(i)) / paprs(i, 1)
       END IF
     END IF
     zx_alf1 = 1.0
     zx_alf2 = 1.0 - zx_alf1
-    zxt = (t(i,1)+z(i,1)*rg/rcpd/(1.+rvtmp2*q(i,1)))*(1.+retv*q(i,1))*zx_alf1 &
-      + (t(i,2)+z(i,2)*rg/rcpd/(1.+rvtmp2*q(i,2)))*(1.+retv*q(i,2))*zx_alf2
-    zxu = u(i, 1)*zx_alf1 + u(i, 2)*zx_alf2
-    zxv = v(i, 1)*zx_alf1 + v(i, 2)*zx_alf2
-    zxq = q(i, 1)*zx_alf1 + q(i, 2)*zx_alf2
-    zxmod = 1.0 + sqrt(zxu**2+zxv**2)
-    khfs(i) = (tsol(i)*(1.+retv*q(i,1))-zxt)*zxmod*cd_h(i)
-    kqfs(i) = (zxqs-zxq)*zxmod*cd_h(i)*beta(i)
-    heatv(i) = khfs(i) + 0.61*zxt*kqfs(i)
-    taux = zxu*zxmod*cd_m(i)
-    tauy = zxv*zxmod*cd_m(i)
-    ustar(i) = sqrt(taux**2+tauy**2)
+    zxt = (t(i, 1) + z(i, 1) * rg / rcpd / (1. + rvtmp2 * q(i, 1))) * (1. + retv * q(i, 1)) * zx_alf1 &
+            + (t(i, 2) + z(i, 2) * rg / rcpd / (1. + rvtmp2 * q(i, 2))) * (1. + retv * q(i, 2)) * zx_alf2
+    zxu = u(i, 1) * zx_alf1 + u(i, 2) * zx_alf2
+    zxv = v(i, 1) * zx_alf1 + v(i, 2) * zx_alf2
+    zxq = q(i, 1) * zx_alf1 + q(i, 2) * zx_alf2
+    zxmod = 1.0 + sqrt(zxu**2 + zxv**2)
+    khfs(i) = (tsol(i) * (1. + retv * q(i, 1)) - zxt) * zxmod * cd_h(i)
+    kqfs(i) = (zxqs - zxq) * zxmod * cd_h(i) * beta(i)
+    heatv(i) = khfs(i) + 0.61 * zxt * kqfs(i)
+    taux = zxu * zxmod * cd_m(i)
+    tauy = zxv * zxmod * cd_m(i)
+    ustar(i) = sqrt(taux**2 + tauy**2)
     ustar(i) = max(sqrt(ustar(i)), 0.01)
   END DO
@@ -178,5 +177,5 @@
     check(i) = .TRUE.
     pblh(i) = z(i, 1)
-    obklen(i) = -t(i, 1)*ustar(i)**3/(rg*vk*heatv(i))
+    obklen(i) = -t(i, 1) * ustar(i)**3 / (rg * vk * heatv(i))
   END DO
 
@@ -190,14 +189,14 @@
     DO i = 1, knon
       IF (check(i)) THEN
-        zdu2 = (u(i,k)-u(i,1))**2 + (v(i,k)-v(i,1))**2 + fac*ustar(i)**2
+        zdu2 = (u(i, k) - u(i, 1))**2 + (v(i, k) - v(i, 1))**2 + fac * ustar(i)**2
         zdu2 = max(zdu2, 1.0E-20)
-        ztvd = (t(i,k)+z(i,k)*0.5*rg/rcpd/(1.+rvtmp2*q(i, &
-          k)))*(1.+retv*q(i,k))
-        ztvu = (t(i,1)-z(i,k)*0.5*rg/rcpd/(1.+rvtmp2*q(i, &
-          1)))*(1.+retv*q(i,1))
-        rino(i, k) = (z(i,k)-z(i,1))*rg*(ztvd-ztvu)/(zdu2*0.5*(ztvd+ztvu))
-        IF (rino(i,k)>=ricr) THEN
-          pblh(i) = z(i, k-1) + (z(i,k-1)-z(i,k))*(ricr-rino(i,k-1))/(rino(i, &
-            k-1)-rino(i,k))
+        ztvd = (t(i, k) + z(i, k) * 0.5 * rg / rcpd / (1. + rvtmp2 * q(i, &
+                k))) * (1. + retv * q(i, k))
+        ztvu = (t(i, 1) - z(i, k) * 0.5 * rg / rcpd / (1. + rvtmp2 * q(i, &
+                1))) * (1. + retv * q(i, 1))
+        rino(i, k) = (z(i, k) - z(i, 1)) * rg * (ztvd - ztvu) / (zdu2 * 0.5 * (ztvd + ztvu))
+        IF (rino(i, k)>=ricr) THEN
+          pblh(i) = z(i, k - 1) + (z(i, k - 1) - z(i, k)) * (ricr - rino(i, k - 1)) / (rino(i, &
+                  k - 1) - rino(i, k))
           check(i) = .FALSE.
         END IF
@@ -232,7 +231,7 @@
   DO i = 1, knon
     IF (check(i)) THEN
-      phiminv(i) = (1.-binm*pblh(i)/obklen(i))**onet
-      wm(i) = ustar(i)*phiminv(i)
-      therm(i) = heatv(i)*fak/wm(i)
+      phiminv(i) = (1. - binm * pblh(i) / obklen(i))**onet
+      wm(i) = ustar(i) * phiminv(i)
+      therm(i) = heatv(i) * fak / wm(i)
       rino(i, 1) = 0.0
     END IF
@@ -245,14 +244,14 @@
     DO i = 1, knon
       IF (check(i)) THEN
-        zdu2 = (u(i,k)-u(i,1))**2 + (v(i,k)-v(i,1))**2 + fac*ustar(i)**2
+        zdu2 = (u(i, k) - u(i, 1))**2 + (v(i, k) - v(i, 1))**2 + fac * ustar(i)**2
         zdu2 = max(zdu2, 1.0E-20)
-        ztvd = (t(i,k)+z(i,k)*0.5*rg/rcpd/(1.+rvtmp2*q(i, &
-          k)))*(1.+retv*q(i,k))
-        ztvu = (t(i,1)+therm(i)-z(i,k)*0.5*rg/rcpd/(1.+rvtmp2*q(i, &
-          1)))*(1.+retv*q(i,1))
-        rino(i, k) = (z(i,k)-z(i,1))*rg*(ztvd-ztvu)/(zdu2*0.5*(ztvd+ztvu))
-        IF (rino(i,k)>=ricr) THEN
-          pblh(i) = z(i, k-1) + (z(i,k-1)-z(i,k))*(ricr-rino(i,k-1))/(rino(i, &
-            k-1)-rino(i,k))
+        ztvd = (t(i, k) + z(i, k) * 0.5 * rg / rcpd / (1. + rvtmp2 * q(i, &
+                k))) * (1. + retv * q(i, k))
+        ztvu = (t(i, 1) + therm(i) - z(i, k) * 0.5 * rg / rcpd / (1. + rvtmp2 * q(i, &
+                1))) * (1. + retv * q(i, 1))
+        rino(i, k) = (z(i, k) - z(i, 1)) * rg * (ztvd - ztvu) / (zdu2 * 0.5 * (ztvd + ztvu))
+        IF (rino(i, k)>=ricr) THEN
+          pblh(i) = z(i, k - 1) + (z(i, k - 1) - z(i, k)) * (ricr - rino(i, k - 1)) / (rino(i, &
+                  k - 1) - rino(i, k))
           check(i) = .FALSE.
         END IF
@@ -287,5 +286,5 @@
 
   DO i = 1, knon
-    pblmin = 700.0*ustar(i)
+    pblmin = 700.0 * ustar(i)
     pblh(i) = max(pblh(i), pblmin)
   END DO
@@ -295,5 +294,5 @@
   DO i = 1, knon
     pblk(i) = 0.0
-    fak1(i) = ustar(i)*pblh(i)*vk
+    fak1(i) = ustar(i) * pblh(i) * vk
 
     ! Do additional preparation for unstable cases only, set temperature
@@ -301,11 +300,11 @@
 
     IF (unstbl(i)) THEN
-      zxt = (t(i,1)-z(i,1)*0.5*rg/rcpd/(1.+rvtmp2*q(i,1)))*(1.+retv*q(i,1))
-      phiminv(i) = (1.-binm*pblh(i)/obklen(i))**onet
-      phihinv(i) = sqrt(1.-binh*pblh(i)/obklen(i))
-      wm(i) = ustar(i)*phiminv(i)
-      fak2(i) = wm(i)*pblh(i)*vk
-      wstr(i) = (heatv(i)*rg*pblh(i)/zxt)**onet
-      fak3(i) = fakn*wstr(i)/wm(i)
+      zxt = (t(i, 1) - z(i, 1) * 0.5 * rg / rcpd / (1. + rvtmp2 * q(i, 1))) * (1. + retv * q(i, 1))
+      phiminv(i) = (1. - binm * pblh(i) / obklen(i))**onet
+      phihinv(i) = sqrt(1. - binh * pblh(i) / obklen(i))
+      wm(i) = ustar(i) * phiminv(i)
+      fak2(i) = wm(i) * pblh(i) * vk
+      wstr(i) = (heatv(i) * rg * pblh(i) / zxt)**onet
+      fak3(i) = fakn * wstr(i) / wm(i)
     END IF
   END DO
@@ -321,13 +320,13 @@
       unslev(i) = .FALSE.
       stblev(i) = .FALSE.
-      zm(i) = z(i, k-1)
+      zm(i) = z(i, k - 1)
       zp(i) = z(i, k)
       IF (zkmin==0.0 .AND. zp(i)>pblh(i)) zp(i) = pblh(i)
       IF (zm(i)<pblh(i)) THEN
-        zmzp = 0.5*(zm(i)+zp(i))
-        zh(i) = zmzp/pblh(i)
-        zl(i) = zmzp/obklen(i)
+        zmzp = 0.5 * (zm(i) + zp(i))
+        zh(i) = zmzp / pblh(i)
+        zl(i) = zmzp / obklen(i)
         zzh(i) = 0.
-        IF (zh(i)<=1.0) zzh(i) = (1.-zh(i))**2
+        IF (zh(i)<=1.0) zzh(i) = (1. - zh(i))**2
 
         ! stblev for points zm < plbh and stable and neutral
@@ -348,7 +347,7 @@
       IF (stblev(i)) THEN
         IF (zl(i)<=1.) THEN
-          pblk(i) = fak1(i)*zh(i)*zzh(i)/(1.+betas*zl(i))
+          pblk(i) = fak1(i) * zh(i) * zzh(i) / (1. + betas * zl(i))
         ELSE
-          pblk(i) = fak1(i)*zh(i)*zzh(i)/(betas+zl(i))
+          pblk(i) = fak1(i) * zh(i) * zzh(i) / (betas + zl(i))
         END IF
         pcfm(i, k) = pblk(i)
@@ -376,7 +375,7 @@
     DO i = 1, knon
       IF (unssrf(i)) THEN
-        term = (1.-betam*zl(i))**onet
-        pblk(i) = fak1(i)*zh(i)*zzh(i)*term
-        pr(i) = term/sqrt(1.-betah*zl(i))
+        term = (1. - betam * zl(i))**onet
+        pblk(i) = fak1(i) * zh(i) * zzh(i) * term
+        pr(i) = term / sqrt(1. - betah * zl(i))
       END IF
     END DO
@@ -386,9 +385,9 @@
     DO i = 1, knon
       IF (unsout(i)) THEN
-        pblk(i) = fak2(i)*zh(i)*zzh(i)
-        cgs(i, k) = fak3(i)/(pblh(i)*wm(i))
-        cgh(i, k) = khfs(i)*cgs(i, k)
-        pr(i) = phiminv(i)/phihinv(i) + ccon*fak3(i)/fak
-        cgq(i, k) = kqfs(i)*cgs(i, k)
+        pblk(i) = fak2(i) * zh(i) * zzh(i)
+        cgs(i, k) = fak3(i) / (pblh(i) * wm(i))
+        cgh(i, k) = khfs(i) * cgs(i, k)
+        pr(i) = phiminv(i) / phihinv(i) + ccon * fak3(i) / fak
+        cgq(i, k) = kqfs(i) * cgs(i, k)
       END IF
     END DO
@@ -399,9 +398,8 @@
       IF (unslev(i)) THEN
         pcfm(i, k) = pblk(i)
-        pcfh(i, k) = pblk(i)/pr(i)
+        pcfh(i, k) = pblk(i) / pr(i)
       END IF
     END DO
   END DO ! end of level loop
 
-
 END SUBROUTINE nonlocal
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/nuage.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/nuage.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/nuage.F90	(revision 5143)
@@ -343,4 +343,7 @@
 SUBROUTINE diagcld2(paprs, pplay, t, q, diafra, dialiq)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
 
@@ -374,8 +377,4 @@
   REAL zqs, zrhb, zcll, zdthmin(klon), zdthdp
   REAL zdelta, zcor
-
-  ! Fonctions thermodynamiques:
-  include "YOETHF.h"
-  include "FCTTRE.h"
 
   ! Initialisation:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/orografi.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/orografi.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/orografi.F90	(revision 5143)
@@ -118,4 +118,8 @@
 
   USE dimphy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+  USE lmdz_libmath, ONLY: ismax, ismin
+
   IMPLICIT NONE
 
@@ -148,15 +152,4 @@
   ! implicit LOGICAL (l)
 
-  ! method.
-  ! -------
-
-  ! externals.
-  ! ----------
-  INTEGER ismin, ismax
-  EXTERNAL ismin, ismax
-
-  ! reference.
-  ! ----------
-
   ! author.
   ! -------
@@ -167,5 +160,4 @@
 
   include "YOMCST.h"
-  include "YOEGWD.h"
   ! -----------------------------------------------------------------------
 
@@ -385,8 +377,10 @@
   ! -----------------------------------------------------------------------
   USE dimphy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
   IMPLICIT NONE
 
   include "YOMCST.h"
-  include "YOEGWD.h"
 
   ! -----------------------------------------------------------------------
@@ -820,7 +814,9 @@
   ! -----------------------------------------------------------------------
   USE dimphy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
   IMPLICIT NONE
   include "YOMCST.h"
-  include "YOEGWD.h"
 
   ! -----------------------------------------------------------------------
@@ -942,8 +938,10 @@
   ! -----------------------------------------------------------------------
   USE dimphy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
   IMPLICIT NONE
 
   include "YOMCST.h"
-  include "YOEGWD.h"
 
   ! -----------------------------------------------------------------------
@@ -1273,8 +1271,10 @@
   USE dimphy
   USE lmdz_abort_physic, ONLY: abort_physic
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
   IMPLICIT NONE
 
   include "YOMCST.h"
-  include "YOEGWD.h"
   ! -----------------------------------------------------------------------
 
@@ -1515,4 +1515,6 @@
   USE lmdz_phys_para
   USE lmdz_grid_phy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
   ! USE parallel
 
@@ -1559,8 +1561,4 @@
   ! ------------------------------------------------------------------
   IMPLICIT NONE
-
-  ! -----------------------------------------------------------------
-  include "YOEGWD.h"
-  ! ----------------------------------------------------------------
 
   INTEGER nlon, nlev, jk
